#!/usr/local/bin/perl
# scan a hex file and echo bytes as ascii on the right side

use strict;

while(<>) {

    chomp;
    s/\s+$//;   # kill trailing spaces

    my $line = $_;
    $line .= " " x (64-length($line));  # pad with spaces to constant length

    my ($addr,$data) = /^(....):(( [0-9a-fA-F]{2})+)/;
    if (!$data) {
	print $line, "\n";
	next;
    }

    print $line;
    for my $byte (split " ", $data) {
	my $val = hex($byte);
	if ($val < 32 || $val > 127) {
	    print ".";
	} else {
	    printf("%c",$val);
	}
    }
    print "\n";
}
